import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;

/** La classe ListeCellulesLibres permet de modliser graphiquement 
 * une liste de cellules libres en utilisant Swing.
 *  
 * @author Eric Beuque et Stphane Chenevoy
 *
 */
public class ListeCellulesLibres extends Liste{
	/** Construit une liste de cellules libres vide au point de coordonne (0,0).
	 */
	public ListeCellulesLibres(){
		super();
	}
	public boolean isPointSurTeteListe(Point p){
		if(p.x>this.getCentre().x-10 && p.x<this.getCentre().x+10 
				&& p.y>this.getCentre().y-10 && p.y<this.getCentre().y+10){
			return true;
		}else{
			return false;
		}
	}
	public Maillon renvoiMaillonSousPoint(Point p){
		Maillon m;
		m=this.getTete();
		while(m!=null){
			if(m.isPointSurMaillon(p)){
				return m;
			}
			m=m.getSuivant();
		}
		return null;
	}
	/* Mthodes d'action sur les listes */ 
	public void ajouterMaillon(Maillon m){
		if(m!=null){
			m.setSuivant(this.getTete());
			this.setTete(m);
			this.recalcCentreMaillon();
		}
	}
	public void retirerMaillon(){
		if(this.getTete()!=null){
			this.setTete(this.getTete().getSuivant());
			this.recalcCentreMaillon();
		}
	}
	public void retirerMaillon(Maillon m){
		Maillon tmp;
		if(this.getTete()!=null){
			if(this.getTete()==m){
				this.setTete(m.getSuivant());
			}else{
				tmp=this.getTete();
				while(tmp.getSuivant()!=m && tmp.getSuivant()!=null){
					tmp=tmp.getSuivant();
				}
				tmp.setSuivant(m.getSuivant());
			}
		}
		this.recalcCentreMaillon();
	}
	public void recalcCentreMaillon(){
		Maillon m;
		if(this.getTete()!=null){
			m=this.getTete();
			m.setCentre(new Point(this.getCentre().x+40,this.getCentre().y));
			while(m.getSuivant()!=null){
				m.getSuivant().setCentre(new Point(m.getCentre().x+90,m.getCentre().y));
				m=m.getSuivant();
			}
		}
	}
	public void paint(Graphics g){
		if(this.getSelected()){
			g.setColor(Color.lightGray);
			g.fillOval(this.getCentre().x-10,this.getCentre().y-10,20,20);
			g.setColor(Color.black);
		}
		g.drawOval(this.getCentre().x-10,this.getCentre().y-10,20,20);
		g.fillOval(this.getCentre().x-3,this.getCentre().y-3,6,6);
		if(getEtendu()==true){
			g.drawLine(this.getCentre().x,this.getCentre().y,this.getCentre().x+40,this.getCentre().y);
			if(this.getTete()==null){
				g.drawLine(this.getCentre().x+40,this.getCentre().y-10,this.getCentre().x+40,this.getCentre().y+10);
				g.drawLine(this.getCentre().x+42,this.getCentre().y-7,this.getCentre().x+42,this.getCentre().y+7);
				g.drawLine(this.getCentre().x+44,this.getCentre().y-4,this.getCentre().x+44,this.getCentre().y+4);
			}else{
				g.drawLine(this.getCentre().x+37,this.getCentre().y-3,this.getCentre().x+40,this.getCentre().y);
				g.drawLine(this.getCentre().x+37,this.getCentre().y+3,this.getCentre().x+40,this.getCentre().y);
				this.getTete().paint(g);
			}
		}
	}
}
